package LectureGame.Core;

import LectureGame.DataBase.DataBaseConnection;

import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: olekrst
 * Date: 10.jan.2007
 * Time: 17:48:31
 * To change this template use File | Settings | File Templates.
 */
public class NetworkConnectionKeeper {

    private boolean connecionsIsDirty;
    private boolean serverIsAlive;
    private Vector<StudentClient> connections;
    private Vector<StudentClient> loggedInConnections;

    private MasterClient masterClient;
    private int connectionCounter;
    private DataBaseConnection db;
    private NetworkManager netManager;


    public NetworkConnectionKeeper(NetworkManager netManager) {
        loggedInConnections = new Vector<StudentClient>();
        this.netManager = netManager;
        connections = new Vector<StudentClient>();
        db = new DataBaseConnection();
        connectionCounter = 0;
        masterClient = null;
        serverIsAlive = true;
        connecionsIsDirty = true;
    }



    private void shutDownServer() {
        serverIsAlive = false;
        int temp = 0;
        while (!connections.isEmpty()) {
            StudentClient c = connections.remove(temp);
            c.close();
        }
    }


    public void removeConnection(StudentClient toBeRemoved) {
        ConsoleWriter.printErr("Client " + toBeRemoved.getUsername() + " has been removed");
        connections.remove(toBeRemoved);
        connectionCounter--;
    }

    public void addConnection(StudentClient c) {
        connections.add(c);
        connectionCounter++;
        connecionsIsDirty = true;
    }

    public void addMaster(MasterClient m) {
        this.masterClient = m;
    }

    public boolean removeMaster() {

        if (masterClient != null) {
            masterClient = null;
            return true;
        }
        return false;
    }

    public MasterClient getMaster() {
        return masterClient;
    }

    public int getConnectionCounter() {
        return connectionCounter;
    }

    public boolean getServerIsAlive() {
        return serverIsAlive;
    }

    public Vector<StudentClient> getConnections() {
        return connections;
    }

    public Vector<StudentClient> getLoggedInConnections() {

        if (connecionsIsDirty) {
            Vector<StudentClient> returnValues = new Vector<StudentClient>();

            int size = connections.size();
            for (int i = 0; i < size; i++) {
                StudentClient c = connections.get(i);
                if (c.loginStatus()) returnValues.add(c);
            }
            connecionsIsDirty = false;
            loggedInConnections = returnValues;
        }

        return loggedInConnections;

    }

    public DataBaseConnection getDatabase() {
        return db;
    }

    public NetworkManager getNetworkManager() {
        return netManager;
    }

}



