package graphics;

import java.awt.Dimension;

import javax.media.opengl.GL;

import com.sun.opengl.util.j2d.TextRenderer;
/**
 * Represent the state and performs the rendering of  the avatar in Elimination mode.
 * 
 * @author Terje
 *
 */
public class Buddy {

	String name;
	boolean isKilled = false;
	private int xpos = 0;
	private int ypos = 0;
	private int blinkOffset;
	private boolean doneDrawing = false;
	private float rot = 0.0f;
	private int personality = 0;
	
	public Buddy(String name){
		this.personality = ((int)(Math.random()*2));
		this.name = name;
		blinkOffset = ((int)(Math.random()*5000)) + 700;
	}
	
	/**
	 * initiates the killing of the avatar.
	 *
	 */
	public void kill(){
		isKilled = true;
	}
	
	/**
	 * The returned value indicates wether the avatar is currently blinking.
	 * 
	 * @return
	 */
	public boolean checkBlink(){
		if(System.currentTimeMillis()%blinkOffset > blinkOffset-250){
			return true;
		} else {
			return false;
		}
	}
	
	public boolean isKilled(){
		return isKilled;
	}
	
	/**
	 * Renders the avatar on the gl object.
	 * 
	 * @param gl
	 * @param textRenderer
	 */
	public void display(GL gl, TextRenderer textRenderer){
		if((isKilled)&&(!doneDrawing)){
			if(personality!=0){
				gl.glRotatef(rot, 1.0f, 0.0f, 0.0f);

				gl.glTranslatef(0.0f, -rot/7, -rot/5);
			} else {
				gl.glRotatef(rot*4, 1.0f, 0.0f, 0.0f);
			}
		}
		if(!doneDrawing){
			gl.glBegin(GL.GL_QUADS);  
			gl.glTexCoord2f(0.0f, 0.0f);
			gl.glVertex3f(-1.0f, -1.0f, 1.0f);
			gl.glTexCoord2f(1.0f, 0.0f);
			gl.glVertex3f(1.0f, -1.0f, 1.0f);
			gl.glTexCoord2f(1.0f, 1.0f);
			gl.glVertex3f(1.0f, 1.0f, 1.0f);
			gl.glTexCoord2f(0.0f, 1.0f);
			gl.glVertex3f(-1.0f, 1.0f, 1.0f);
			gl.glEnd();				// Done Drawing The Quad
			gl.glFlush();
		}

		if((isKilled)&&(!doneDrawing)){
			if(personality!=0){
			gl.glTranslatef(0.0f, rot/7, rot/5);
			gl.glRotatef(-rot, 1.0f, 0.0f, 0.0f);
			} else {
				gl.glRotatef(-rot*4, 1.0f, 0.0f, 0.0f);
			}



			rot  += 1.5f;

		}
		String shortname = "";
		if(name.length()>11){
			shortname = name.substring(0,12);
		}else {
			shortname = name;
		}
		textRenderer.begin3DRendering();
		textRenderer.draw3D(shortname, -1.0f, -1.50f, 1.0f, 0.027f);
		textRenderer.end3DRendering();
		

		if(rot>45.0f)
			doneDrawing = true;

	}

	/**
	 * Sets the position of the avatar in the on-screen grid of avatars.
	 * 
	 * @param x
	 * @param y
	 */
	public void setGridXY(int x, int y) {
		xpos = x;
		ypos = y;
		
	}
	
	/**
	 * 
	 * Returns the coordiantes of the avatar in the on-screen grid of avatars.
	 * 
	 * @return
	 */
	public Dimension getGridXY(){
		return(new Dimension(xpos,ypos));
	}

	public String getName() {
		return name;
	}
}
