package graphics;

import java.util.ArrayList;

/**
 * Logical representation of a question and all its state and parameters.
 * 
 * @author Terje
 *
 */
public class QuestionGraphics {

	private String question;
	private boolean startedPosing;
	private boolean processing;
	private int timeLimit;
	private ArrayList<String> alternatives;
	private int correctAlternativeIndex = -1;


	public QuestionGraphics(){
		startedPosing = false;
		processing = false;
		question = "";
		alternatives = new ArrayList<String>();

	}

	public boolean isDone() {
		return !(startedPosing&&processing);
	}

	public void doneWithQuestion(boolean done) {
		this.startedPosing = false;
		this.processing = false;
		question = "";
		
	}

	public boolean isProcessing() {
		return processing;
	}

	public void setProcessing() {
		this.processing = true;
	}

	public synchronized String getQuestion() {
		return question;
	}

	public synchronized void setQuestion(String question) {
		this.question = question;
	}

	public boolean isStartedPosing() {
		return startedPosing;
	}

	public void setStartedPosing(boolean startedPosing) {
		this.startedPosing = true;
	}
	
	public int getTimeLimit() {
		return timeLimit;
	}

	public void setTimeLimit(int timeLimit) {
		this.timeLimit = timeLimit;
	}

	public ArrayList<String> getAlternatives() {
		return alternatives;
	}

	public void setAlternatives(ArrayList<String> alternatives) {
		this.alternatives = alternatives;
	}

	public int getCorrectAlternativeIndex() {
		return correctAlternativeIndex;
	}

	public void setCorrectAlternativeIndex(int correctAlternativeIndex) {
		this.correctAlternativeIndex = correctAlternativeIndex;
	}
	
}
