import javax.microedition.io.SocketConnection;
import javax.microedition.io.Connector;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.TextBox;
import java.io.IOException;
import java.io.OutputStream;
import java.io.InputStream;

/**
 * Created by IntelliJ IDEA.
 * User: ofsdahl
 * Date: 10.jan.2007
 * Time: 15:29:56
 * To change this template use File | Settings | File Templates.
 */
public class ClientNetworkThread implements Runnable {

    protected LeGaMidlet lega;
    protected OutputStream os;
    protected InputStream is;
    protected SocketConnection sc;
    protected int protocolState;
    protected boolean stringBuffered;
    public String received;
    protected Thread networkThread;

    public ClientNetworkThread(LeGaMidlet lega) {
        this.lega = lega;
        sc = null;
        is = null;
        os = null;
        protocolState = Constants.PROT_ENDED_STEP2;
        stringBuffered = false;
        received = null;
        networkThread = Thread.currentThread();

    }


    public synchronized void run() {
        System.err.println("run kalt");
        boolean soFarSoGood = true;
        try {
            sc = (SocketConnection) Connector.open(Constants.SERVER_ADDRESS);
            sc.setSocketOption(SocketConnection.DELAY, 0);
            sc.setSocketOption(SocketConnection.KEEPALIVE, 0);
        } catch (Exception e) {
            soFarSoGood = false;
            lega.networkFailure();
        }


        try {
            is = sc.openInputStream();
        } catch (Exception e) {
            soFarSoGood = false;
            lega.networkFailure();
        }


        try {
            os = sc.openOutputStream();
        } catch (Exception e) {
            soFarSoGood = false;
            lega.networkFailure();
        }

        if (soFarSoGood)
            lega.networkStatus(true);
        else {
            lega.networkStatus(false);
            lega.networkFailure();
        }


        while (true) {
            System.err.println("Sampler linja..");
            received = receive();
            if (!(received==null)) {
                stringBuffered = true;
                System.err.println("Rdata motatt: " + received);
                try {
                    lega.parse(received);
                    System.err.println("nettverkstrd venter..");
                    wait();
                    System.err.println("nettverstrd vekket");
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }

            try {
                Thread.currentThread().sleep(Constants.SAMPLE_RATE);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }


    }

    public synchronized void wakeMe() {
        notifyAll();
    }

    public String receive() {
        String rec = "";
        int ch = 0;
        char[] tempChar = new char[1];
        while (ch != -1) {
            try {
                ch = is.read();
                System.err.print((char)ch);
                tempChar[0] = (char) ch;
                String tempString = new String(tempChar);
                rec = rec + "" + new String(tempChar);
                if ((protocolState == Constants.PROT_ENDED_STEP2)) {
                    if (tempString.equals("@")) {
                        protocolState = Constants.PROT_STARTED_STEP1;
                    } else {
                        rec = "";
                        break;
                    }
                } else if ((protocolState == Constants.PROT_STARTED_STEP1)) {
                    if (tempString.equals("")) {
                        protocolState = Constants.PROT_STARTED_STEP2;
                    } else {
                        rec = "";
                        break;
                    }
                } else if (protocolState == Constants.PROT_STARTED_STEP2) {
                    if (tempString.equals("")) {
                        protocolState = Constants.PROT_ENDED_STEP1;
                    }
                } else if ((protocolState == Constants.PROT_ENDED_STEP1)) {
                    if (tempString.equals("@")) {
                        protocolState = Constants.PROT_ENDED_STEP2;
                        break;
                    } else {
                        protocolState = Constants.PROT_STARTED_STEP2;
                    }
                }


            } catch (IOException
                    e) {
                e.printStackTrace();
            }

        }
        System.err.println(rec);
        if (rec.length() > 3) {
            return rec.substring(2, (rec.length() - 2));
        }
        return null;
    }

    public void close() throws IOException {
        os.close();
        is.close();
        sc.close();
    }

    public void send(String str) {
        try {
            os.write(str.getBytes());
            System.err.println(str);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
