import com.sun.midp.io.Util;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.lcdui.*;
import java.util.Timer;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: ofsdahl
 * Date: 10.jan.2007
 * Time: 15:30:11
 * To change this template use File | Settings | File Templates.
 */
public class LeGaMidlet extends MIDlet implements CommandListener, Runnable {

    protected ClientNetworkThread clientNetwork;
    protected Thread networkThread;
    protected Command okCommand;
    protected boolean connectionOK;
    protected TextField input;
    protected Form inputForm;
    protected Form questionForm;
    protected Form messageFrm;
    public int inputState = Constants.BEGIN_PROGRAM;
    protected Form okForm;
    protected int answerIndex = -1;
    protected ScheduledTask scheduled;


    protected String nickName = "";
    protected String passWord = "";
    protected String lectureCode = "";

    public LeGaMidlet() {
        okForm = new Form("The Lecture Game");
        okForm.append("Hold on! Stay sharp!");
        connectionOK = true;
        okCommand = new Command("OK", Command.OK, 1);
        messageFrm = new Form("Hey!");


    }

    protected void startApp() throws MIDletStateChangeException {

        //start network connection in separate thread
        clientNetwork = new ClientNetworkThread(this);
        networkThread = new Thread(clientNetwork);
        networkThread.start();

        scheduled = new ScheduledTask(clientNetwork);
        //show splash - color/monochrome?

        forcedLogin();

        //prompt lecture code
    }

    protected void forcedLogin() {
        inputForm = new Form("");
        input = new TextField("What's your nickname?", "", 14, TextField.INITIAL_CAPS_WORD);
        input.setConstraints(TextField.NON_PREDICTIVE);
        inputForm.setCommandListener(this);
        inputForm.addCommand(okCommand);
        inputForm.append(input);
        Display.getDisplay(this).setCurrent(inputForm);
        inputState = Constants.ENTER_PASSWORD;

    }

    protected void pauseApp() {

    }

    protected void destroyApp(boolean b) throws MIDletStateChangeException {
        try {
            clientNetwork.close();
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        //close all connections
    }


    public void commandAction(Command command, Displayable displayable) {

        System.err.println("Command motatt");
        if (command.getLabel().equals("OK")) {
            if (inputState == (-1))
                return;
            else if (inputState == Constants.BEGIN_PROGRAM) {
                input = new TextField("What's your nickname?", "", 14, TextField.INITIAL_CAPS_WORD);
                input.setConstraints(TextField.NON_PREDICTIVE);
                inputForm.setCommandListener(this);
                inputForm.addCommand(okCommand);
                Display.getDisplay(this).setCurrent(inputForm);
            } else if (inputState == Constants.ENTER_PASSWORD) {
                nickName = input.getString();
                input.setLabel("Enter password...");
                input.setString("");
                input.setConstraints(TextField.PASSWORD);
                inputState = Constants.ENTER_LECTURE_CODE;

                Display.getDisplay(this).setCurrent(inputForm);

            } else if (inputState == Constants.ENTER_LECTURE_CODE) {
                passWord = input.getString();
                input.setLabel("Please enter the lecture code");
                input.setString("");
                input.setConstraints(TextField.NON_PREDICTIVE);
                inputState = Constants.READY_FOR_LOGIN;
                Display.getDisplay(this).setCurrent(inputForm);
            } else if (inputState == Constants.READY_FOR_LOGIN) {
                lectureCode = input.getString();
                if (!connectionOK) {
                    messageFrm.append("We're just wating for the Internet.. Hang on..");
                    Display.getDisplay(this).setCurrent(messageFrm);
                    inputState = Constants.WAITING_FOR_CONNECTION;

                }
                clientNetwork.send("@LGN" + nickName + "|" + passWord + "|" + lectureCode + "@");
                waitIDLE();
            } else if (inputState == Constants.QUESTION_POSED) {
                answerIndex = ((ChoiceGroup) questionForm.get(0)).getSelectedIndex();
                clientNetwork.send("@ANS" + answerIndex + "@");
                inputState = Constants.QUESTION_ANSWERED;
                questionForm.append("Please wait...");
                Display.getDisplay(this).setCurrent(questionForm);
                clientNetwork.wakeMe();
                
            } else if (inputState == Constants.USER_NOT_FOUND) {
                if (command.getLabel().equals("New User")) {
                    clientNetwork.send("@REG" + nickName + "|" + passWord + "|" + lectureCode + "@");
                    waitIDLE();
                } else {
                    inputState = Constants.BEGIN_PROGRAM;
                    forcedLogin();
                }
            }


        }

    }


    public void networkFailure() {
        if (inputState != (-1)) {
            inputState = -1;
            messageFrm.append("Sorry.. Couldn't get a network connection. Restarting the application later might work..");
            Display.getDisplay(this).setCurrent(messageFrm);
        }
    }

    public void parse(String received) {
        int numberOfFields = 0;
        String[] stringList = new String[Constants.MAX_NUMBER_OF_FIELDS_IN_MSG];
        String code = received.substring(0, 3);
        received = received.substring(3, received.length());
        while (numberOfFields < Constants.MAX_NUMBER_OF_FIELDS_IN_MSG) {
            int msgLength = received.indexOf("|");
            if (msgLength == (-1)) {
                stringList[numberOfFields] = received.substring(0, received.length());
                numberOfFields++;
                break;
            } else {
                stringList[numberOfFields] = received.substring(0, Math.abs(msgLength));
                received = received.substring(msgLength + 1, received.length());
                //System.err.println(received + " " + msgLength);
                numberOfFields++;
            }
        }
        //for (int k = 0; k < numberOfFields; k++) {
        //    System.err.println(stringList[k]);
        //}
        if (code.equals("QST") && (inputState == Constants.LOGGED_IN)) {
            String question = stringList[0];
            int nbrOfAlternatives = Integer.parseInt(stringList[1]);
            int seconds = Integer.parseInt(stringList[nbrOfAlternatives + 2]);
            questionForm = new Form("Question!");
            String[] alternatives = new String[nbrOfAlternatives];
            for (int i = 0; i < nbrOfAlternatives; i++) {
                alternatives[i] = stringList[i + 2];
            }
            ChoiceGroup choiceGroup = new ChoiceGroup(question, Choice.EXCLUSIVE, alternatives, null);
            questionForm.append(choiceGroup);
            questionForm.addCommand(okCommand);
            questionForm.setCommandListener(this);
            inputState = Constants.QUESTION_POSED;
            new Timer().schedule(new ScheduledTask(this), (long) (seconds * 1000));
            Display.getDisplay(this).setCurrent(questionForm);
            } else if (code.equals("LGN")) {
            System.err.println(stringList[0]);
            if (stringList[0].equals("OK")) {
                inputState = Constants.LOGGED_IN;
            } else {
                messageFrm.deleteAll();
                messageFrm.addCommand(new Command("New User", Command.SCREEN, 2));
                messageFrm.addCommand(new Command("Retry", Command.SCREEN, 1));
                messageFrm.append("No one we know! Is this a new user, or would you like to retry logging in?");
                Display.getDisplay(this).setCurrent(messageFrm);
                inputState = Constants.USER_NOT_FOUND;
            }

        } else if (code.equals("RES")) {
            Alert al;
            messageFrm.deleteAll();
            if (answerIndex != Integer.parseInt(stringList[0])) {
                al = new Alert("WRONG ANSWER", "Current score " + (stringList[1]) + " out of  " + (stringList[2]) + " possible points", null, AlertType.ERROR);
                Display.getDisplay(this).vibrate(1000);

            } else {
                al = new Alert("CORRECT ANSWER", "Current score " + (stringList[1]) + " / " + (stringList[2]), null, AlertType.ERROR);
                Display.getDisplay(this).flashBacklight(1000);

            }
            al.setTimeout(3000);

            new Timer().schedule(new ScheduledTask(clientNetwork), 3000);
            Display.getDisplay(this).setCurrent(al, okForm);
            inputState = Constants.LOGGED_IN;


        } else if (code.equals("DIE")) {
            messageFrm.deleteAll();
            messageFrm.append("Your final score: " + stringList[0]);
            messageFrm.append("Max achievable score: " + stringList[1]);
            messageFrm.append("Thanks for playing..");
           Display.getDisplay(this).setCurrent(messageFrm);
        }
        clientNetwork.received = null;
    }

    private void waitIDLE() {
        System.err.println("waitIdle kjres");
        Display.getDisplay(this).setCurrent(okForm);
        if (!(clientNetwork.received == null)) {
            parse(clientNetwork.received);
        }
        System.err.println("GUItrd kjrt ferdig");

        clientNetwork.wakeMe();
        System.err.println("GUItrd kjrt ferdig2");

    }

    public void networkStatus(boolean connectionOK) {
        this.connectionOK = connectionOK;
        if (inputState == Constants.WAITING_FOR_CONNECTION && connectionOK) {

        } else if (!connectionOK) {
            networkFailure();
        }
    }

    public void run() {

    }

    public void timesUp() {
        System.out.println("inputState " + inputState);
        if (inputState == Constants.QUESTION_POSED) {
            inputState = Constants.LOGGED_IN;
            Alert al = new Alert("Time's up", "Too late, mate! ", null, AlertType.INFO);

            al.setTimeout(Constants.STD_HOLD_SCREEN_MILLISECONDS);
            Display.getDisplay(this).setCurrent(al,okForm);
            clientNetwork.wakeMe();
            //clientNetwork.send("@ANS-1@");
            //waitIDLE();
        }

    }


}


